apiVersion: networking.istio.io/v1alpha3
kind: VirtualService
metadata:
  namespace: workshop
  name: middleware
spec:
  hosts:
    - middleware
  http:
    - match:
        - headers:
            x-istio-formation-middleware:
              exact: upgrade # <1>
      route:
        - destination:
            host: middleware
            subset: version-2 # <2>
    - route:
        - destination:
            host: middleware
            subset: version-1 # <3>
---
apiVersion: networking.istio.io/v1alpha3
kind: DestinationRule
metadata:
  namespace: workshop
  name: middleware
spec:
  host: middleware
  subsets:
    - name: version-1
      labels:
        version: v1
    - name: version-2
      labels:
        version: v2